chiark / gitweb /
dot/ipython_config.py: Let's just have one of these for everywhere.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
563555cf 13: ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
4fc3203b 136 vimrc mg zile lesskey
bb65ad08 137 parallel-config:.parallel/config
27be52b3 138 ipython_config.py:.ipython/profile_default/ipython_config.py
30169591 139 ditz-config
ce39049e 140 mailrc signature muttrc
ce178f96 141 cgrc tigrc
e7d23024 142 gdbinit
8a7e906d 143 guile
1d89ce86 144 rcrc
5d25e440 145 toprc
a6a6806a 146 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
f56d38cd 147 pulse-daemon.conf:.pulse/daemon.conf
cbffcf2b 148 aspell.conf
78719982 149 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
150 lisp-init.lisp:.cmucl-init.lisp
151 lisp-init.lisp:.sbclrc
152 lisp-init.lisp:.clisprc.lisp
f6335a0c 153 lisp-init.lisp:.eclrc
b5bf3445 154 swank.lisp
5a91acc5 155 mdw-build.conf:.config/mdw-build.conf
3ec64a11 156 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
4d60a7ac 157 dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
739bccbf 158[ "$xstuff" ] && dotfiles="$dotfiles
f7cb5c84 159 xinitrc xsession xmodmap vncrc vncsession
5e23020b 160 fonts.conf
e517857c 161 stalonetrayrc
1c6b19d4 162 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 163 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 164 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 165 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 166 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 167 e16-bindings:.e16/bindings.cfg"
f617db13
MW
168echo "Installing dotfiles..."
169for d in $dotfiles; do
739bccbf
MW
170 target=.$d
171 case $d in
172 *:*) target=${d#*:} d=${d%%:*};;
173 esac
174 ft=$HOME$sub/$target
175 dir=${ft%/*}
176 mkdir -p $dir
99063107 177 ln -s $here/dot/$d $ft.new
739bccbf
MW
178 mv $ft.new $ft
179 echo " $target"
f617db13 180done
852cd5fb 181echo " all done."
f617db13 182
f7cb5c84
MW
183## CPP-hack files which need it.
184cppfiles=""
185[ "$xstuff" ] && cppfiles="$cppfiles
186 Xdefaults"
187echo "Hacking files with C preprocessor..."
188for c in $cppfiles; do
189 target=.$c
190 case $c in
191 *:*) target=${c#*:} c=${c%%:*};;
192 esac
193 ft=$HOME$sub/$target
194 dir=${ft%/*}
195 mkdir -p $dir
18312fb5 196 cpp -P dot/$c -o $ft.new
f7cb5c84
MW
197 mv $ft.new $ft
198 echo " $target"
199done
200echo " all done."
201
403dc178
MW
202## Substitute things which need substituting.
203dotfilessubst="
204 gitconfig
8508a859 205 mykermrc
403dc178
MW
206 pulse-default.pa.in:.pulse/default.pa"
207echo "Installing dotfiles with substitutions..."
208for d in $dotfilessubst; do
209 case $d in
210 *:*) target=${d#*:} d=${d%%:*};;
211 *) target=.$d d=$d.in;;
212 esac
213 ft=$HOME$sub/$target
214 dir=${ft%/*}
215 mkdir -p $dir
216 sed "
2b5d4580
MW
2171i\\
218### generated by $here/setup; do not edit!\\
403dc178
MW
219
220/@home@/ s\a\a$HOME\ag
73165cde 221/@profile@/ s\a\a$here\ag
bf674ae1 222/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
403dc178
MW
223" dot/$d >$ft.new
224 mv $ft.new $ft
225 echo " $target"
226done
227echo " all done."
228
f4e43257 229## Symlink backgrounds.
960af1a5 230backgrounds="
5236501e 231 bsg-supper.jpg
9fe91389 232 harley-quinn.jpg
56c871ef 233 hypatia.jpg
7bdd0453 234 jue-peek.jpg
9f56284f 235 lilith.jpg
7bdd0453
MW
236 lovelace.jpg
237 medusa.jpg
238 noodly.jpg
239 rayne.jpg
240"
f4e43257
MW
241if [ "$xstuff" ]; then
242 echo "Installing backgrounds..."
243 for b in $backgrounds; do
244 for e in enlightenment e16; do
245 dir=$HOME$sub/.$e/backgrounds
246 t=$dir/$b
247 mkdir -p $dir
99063107 248 ln -s $here/bg/$b $t.new
f4e43257
MW
249 mv $t.new $t
250 done
251 echo " $b"
252 done
253 echo " all done."
254fi
255
ce178f96
MW
256###--------------------------------------------------------------------------
257### Install useful scripts included in this package.
258
e04c4857 259scripts="
547fb8af 260 mdw-editor
b20bfd83 261 mdw-pager
b056f5c4 262 mdw-conf
b94830d9 263 mdw-build mdw-sbuild mdw-sbuild-server
5f56828b 264 update-buildable-branch
c4e84cb1 265 emacsclient-hack
8e08f814 266 movemail-hack
aaa2d943 267 sendmail-hack
68b2e9e6 268 aspell-hack
285a1386
MW
269 emerge-hack
270 lesspipe.sh
6a5170a8 271 run-with-shell-env
285a1386 272 start-ssh-agent
6a5170a8 273 start-ssh-pageant
4cdeb0d0 274 svnwrap
73bb9001 275 guest-console
4cdeb0d0 276 hyperspec"
8e08f814 277[ "$xstuff" ] && scripts="$scripts
3bdada49 278 xinitcmd
34a5ea4e 279 un-backslashify-selection
c02999e8 280 lock-screen
b7743290 281 xpra-start-xdummy
8e08f814 282 xshutdown"
e04c4857
MW
283echo "Installing scripts..."
284mkdir -p $HOME$sub/bin
285for s in $scripts; do
286 ft=$HOME$sub/bin/$s
99063107 287 ln -s $here/bin/$s $ft.new
e04c4857
MW
288 mv $ft.new $ft
289 echo " $s"
290done
291echo " all done."
292
4d7d040b
MW
293hacks="
294 ssh:ssh"
295echo "Installing hacks..."
296for h in $hacks; do
297 d=${h%%:*} h=${h#*:}
298 ft=$HOME$sub/bin/hacks/$d
299 mkdir -p $ft
300 ln -s $here/hacks/$h $ft/$h.new
301 mv $ft/$h.new $ft/$h
302 echo " $d:$h"
303done
304echo " all done."
305
ce178f96
MW
306###--------------------------------------------------------------------------
307### Set up the Emacs config.
308
65ff0e8c
MW
309$echon "Finding a suitable emacs:$echoc"
310emacs=no
f7876fa9 311for i in emacs23 emacs24 emacs22 emacs21 emacs; do
65ff0e8c
MW
312 if type -p >/dev/null $i; then
313 emacs=$i
314 break
315 fi
316done
317if [ $emacs = no ]; then
318 echo " failed."
319 emacs=:
320else
321 echo " $emacs."
322fi
323
f617db13 324echo "Installing Emacs packages..."
400223a1
MW
325emacspkg="
326 make-regexp
a1293ade 327 ew-hols
a3bdb4d9 328 mdw-gnus-patch
1778b496 329 git git-blame vc-git stgit
c6fe19d5 330 mdw-multiple-cursors
400223a1
MW
331 quilt"
332for elib in $emacspkg; do
f617db13 333 $echon " $elib:$echoc"
65ff0e8c 334 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 335 (progn
852cd5fb
MW
336 (setq load-path (nconc load-path (list "~/lib/emacs")))
337 (kill-emacs (condition-case nil
338 (progn (load-library "'"$elib"'") 0)
20eb0692 339 (error 1))))'; then
f617db13
MW
340 echo " already installed."
341 else
99063107
MW
342 if [ -f el/$elib.el ]; then
343 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
344 else
345 $echon " downloading$echoc"
346 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
347 fi
f617db13
MW
348 $echon " compiling$echoc"
349 (cd $HOME$sub/lib/emacs;
65ff0e8c 350 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 351 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
352 echo " done."
353 fi
354done
852cd5fb 355echo " all done."
f617db13
MW
356
357$echon "Setting up Emacs configuration:$echoc"
358$echon " linking$echoc"
99063107 359for f in dot-emacs.el Makefile; do
f617db13 360 set -- $(echo $link | tr : ' ')
99063107
MW
361 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
362 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
363done
364$echon " compiling$echoc"
c39d1139 365{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 366echo " done."
ce178f96
MW
367
368###----- That's all, folks --------------------------------------------------